%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Economic value %%%%%%%%%%%%%%%%
% pred is the forecast for RV
% y is observed RV
% ret is log return
% h is ETF holding period
% riskAver is risk aversion

function [utility_] =econ_eval(pred,y,ret,h)

rf=0.012/252*h;
riskAver=5;
flag_tc=0;
flag_shortsale=0;
flag_leverage=0;

m=size(ret,1);
id=[1:1:m]';
id=id(1:h:end);

pred=pred(id,1);
y=y(id,1);
ret=ret(id,1);

RV=cell2mat(y');
RV=sum(RV(1:h,:),1)';
ret=cell2mat(ret');
ret=sum(ret(1:h,:),1)';
for i=1:size(pred,1)
    rvf=pred{i,1};
RVf(i,:)=sum(rvf(:,1:h),2)';
end

for i=1:size(RVf,2)
[utility, ~, ~]=...
    PortfolioAllocation(RV,RVf(:,i),ret,rf,riskAver,...
    flag_tc,flag_shortsale,flag_leverage,h);
utility_(1,i)=utility;
end

end