%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% forecasts for log(RV) and RV %%%%%%%
% y is RV
% K is forecasting horizon

function [logyhat yhat] = fore_fun(y,K)
delta=1;
T=252*2;
para =fbm_est(y,delta);
H=para(1);
sigma2=para(2)*delta^(2*H);

for k=1:K
%% Infinite-past forecasting foremulae
% right Riemann sum
seq=1:1:T-1;
[coef] = w1(T*delta,seq'*delta,k*delta,H);
coef=[coef;coef(end)];
weight1=coef./sum(coef);
% left Riemann sum
seq=0:1:T-1;
[coef] =  w1(T*delta,seq'*delta,k*delta,H);
weight2=coef./sum(coef);
% trapezoidal sum
seq=0:1:T-1;
[coef] =  w1(T*delta,seq'*delta,k*delta,H);
coef=[.5*coef(1,1);coef(2:end-1);coef(end);0.5*coef(end)];
weight3=coef./sum(coef);
% mid sum
seq=0.5:1:T-.5;
[coef] =  w1(T*delta,seq'*delta,k*delta,H);
weight4=coef./sum(coef);
% Gatheral
seq=0:1:T-1;
[coef] = w1(T*delta,seq'*delta,k*delta,H);
weight_1=coef./sum(coef);

%% Finite-past forecasting foremulae
% right Riemann sum
seq=1:1:T-1;
[coef] = w2(T*delta,seq'*delta,k*delta,H);
coef=[coef;coef(end)];
weight5=coef./sum(coef);
% left Riemann sum
seq=1:1:T-1;
[coef] = w2(T*delta,seq'*delta,k*delta,H);
coef=[coef(1);coef];
weight6=coef./sum(coef);
% trapezoidal sum
seq=1:1:T-1;
[coef] = w2(T*delta,seq'*delta,k*delta,H);
coef=[.5*coef(1); coef(1);coef(2:end-1);coef(end);0.5*coef(end)];
weight7=coef./sum(coef);
% mid sum
seq=0.5:1:T-.5;
[coef] = w2(T*delta,seq'*delta,k*delta,H);
weight8=coef./sum(coef);
% similar to the one by Gatheral
seq=1:1:T-1;
[coef] = w2(T*delta,seq'*delta,k*delta,H);
coef=[coef(1);coef];
weight_2=coef./sum(coef);

%% Optimal forecast
[covMatrix] = Covd_fbmd(T+k,H,delta);
covM = covMatrix(1:T+k,1:T+k);
Sigma=covM(1+k:T+k,1+k:T+k);
gamT=covM(1+k:T+k,1);
weight9=inv(Sigma)*(gamT);
CD=Sigma(1,1)-gamT'*inv(Sigma)*gamT;


%% the first element in y is y_0
logyhat(1,k)=sum(y(2:end).*weight1);
logyhat(2,k)=sum(y(1:end-1).*weight2);
logyhat(3,k)=sum(y(1:end).*weight3);
logyhat(4,k)=sum(y(2:end).*weight4);
logyhat(5,k)=sum(y(2:end).*weight_1);
logyhat(6,k)=sum(y(2:end).*weight5);
logyhat(7,k)=sum(y(1:end-1).*weight6);
logyhat(8,k)=sum(y(1:end).*weight7);
logyhat(9,k)=sum(y(2:end).*weight8);
logyhat(10,k)=sum(y(2:end).*weight_2);
logyhat(11,k)=sum(flip(y(2:end)).*weight9);

yhat(:,k)=exp(logyhat(:,k)+.5*sigma2*CD);
end

end