%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Weights in the finite-past formula %%%%%%
% T is rolling window size
% s is time point in T, [1 2 3 ... T]
% k is forecasting horizon
% H is Hurst parameter

function [w] = w2(T,s,k,H)

c=k/T;
t=T-s;

for i=1:size(s,1)
    
w(i,1)=T^(-1)*(t(i)/T)^(-H-0.5)*(1-t(i)/T)^(-H-.5)*...
     ((0.5-H)*betainc(c/(1+c),H+.5,1-2*H)+c^(H+0.5)*(1+c)^(H-.5)*(1-t(i)/T)/(c+t(i)/T));

end

end