%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Generate results for Table 2 %%%%%%
% k is forecasting horizon


k=10; 

for dh=1:6
        
H_=[0.05 0.1 0.15 0.2 0.25 0.4];
H=H_(dh);
T=500;  
N=T+k+1;

%% fGn, covariance matrix gaM
for i=1:N
j=i-1;
gam(i)=.5*((j+1)^(2*H)+((j-1)^2)^H-2*(j)^(2*H));
end
gaM1=zeros(N,N);
for i=1:N-1
gaM1(i+1:end,i)=gam(2:end-i+1);
end
gaM2=gaM1';
gaM=eye(N)+gaM1+gaM2;

%% obtain forecasting errors
parfor i=1:1000000
    i
% generate fBm as the recursive sum of fGn
xb=norm_rnd(gaM);
y=xb;
for j=2:N
y(j)=y(j)+y(j-1);
end

for ii=1:k
w=weigh(T,ii,H);
e{i,ii}=fore_err(y,w,T,ii);
end
end

%% forecasting performance
[srmse smae]=eval_fun(e,k,T,H);
store_rmse(dh,:,:)=srmse';
store_mae(dh,:,:)=smae';

end