%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% performance evaluation %%%%%%
% e is forecasting error
% k is forecasting horizon
% T is the rolling window size
% H is Hurst parameter

function [srmse smae]=eval_fun(e,k,T,H)

for ii=1:k
err=cell2mat(e(:,ii));
err=err';
rmse(1)=(mean(err(1,:).^2)).^.5;
rmse(2)=(mean(err(2,:).^2)).^.5;
rmse(3)=(mean(err(3,:).^2)).^.5;
rmse(4)=(mean(err(4,:).^2)).^.5;
rmse(5)=(mean(err(5,:).^2)).^.5;
rmse(6)=(mean(err(6,:).^2)).^.5;
rmse(7)=(mean(err(7,:).^2)).^.5;
rmse(8)=(mean(err(8,:).^2)).^.5;
rmse(9)=(mean(err(9,:).^2)).^.5;
rmse(10)=(mean(err(10,:).^2)).^.5;
rmse(11)=(mean(err(11,:).^2)).^.5;

mae(1)=(mean(abs(err(1,:))));
mae(2)=(mean(abs(err(2,:))));
mae(3)=(mean(abs(err(3,:))));
mae(4)=(mean(abs(err(4,:))));
mae(5)=(mean(abs(err(5,:))));
mae(6)=(mean(abs(err(6,:))));
mae(7)=(mean(abs(err(7,:))));
mae(8)=(mean(abs(err(8,:))));
mae(9)=(mean(abs(err(9,:))));
mae(10)=(mean(abs(err(10,:))));
mae(11)=(mean(abs(err(11,:))));

% compute the MSE
[covMatrix] = Covd_fbm(T+ii,H);
Sigma=covMatrix(1+ii:T+ii,1+ii:T+ii);
gamT=covMatrix(1+ii:T+ii,1);
weight9=inv(Sigma)*(gamT);
sigma2_y=covMatrix(1,1);
rho=weight9;
mse=(sigma2_y-rho'*Sigma*rho)^.5;
srmse(ii,:)=[rmse mse];
smae(ii,:)=[mae];
end