%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% forecasting error of alternative methods %%%%%%
% y is log(RV)
% w is the weight in alternative forecasting formulae
% T is rolling window size
% k is forecasting horizon

function err=fore_err(y,w,T,k)

weight1=w{1};
weight2=w{2};
weight3=w{3};
weight4=w{4};
weight_1=w{5};
weight5=w{6};
weight6=w{7};
weight7=w{8};
weight8=w{9};
weight_2=w{10};
weight9=w{11};

%% infinite-past forecasting foremulae
err(1,1)=sum(y(2:T+1).*weight1)-y(T+1+k);
err(1,2)=sum(y(1:T).*weight2)-y(T+1+k);
err(1,3)=sum(y(1:T+1).*weight3)-y(T+1+k);
err(1,4)=sum(y(2:T+1).*weight4)-y(T+1+k);
err(1,5)=sum(y(2:T+1).*weight_1)-y(T+1+k);

%% finite-past forecasting foremulae
err(1,6)=sum(y(2:T+1).*weight5)-y(T+1+k);
err(1,7)=sum(y(1:T).*weight6)-y(T+1+k);
err(1,8)=sum(y(1:T+1).*weight7)-y(T+1+k);
err(1,9)=sum(y(2:T+1).*weight8)-y(T+1+k);
err(1,10)=sum(y(2:T+1).*weight_2)-y(T+1+k);

%% optimal forecast
err(1,11)=sum(flip(y(2:T+1)).*weight9)-y(T+1+k);

end